#include "dsbutton.h"

#include <string.h> //memcpy

/**
  * Constructors/Destructors
  */

DSButton::DSButton() {
  m_pos.x = m_pos.y = 0;
  m_dim.width = m_dim.height = 10;
}

DSButton::DSButton( PPOSITION p_pos, PDIMENSIONS p_dim, void (*p_fn)() ) {
  memcpy(&m_pos, p_pos, sizeof(POSITION));
  memcpy(&m_dim, p_dim, sizeof(DIMENSIONS));
  m_p_click_event_fn = p_fn;
}

DSButton::~DSButton() {
  // nothing to do yet.
}

RESULT DSButton::ClickEvent( PPOSITION p_pos ) {
  if (!CheckClickEvent(p_pos))
    return NO_CLICK;

  m_p_click_event_fn();
  return SUCCESS;
}

