#ifndef __DSCONTAINER_H__
#define __DSCONTAINER_H__

#include "dslistenerwidget.h"

class DSContainer: public DSListenerWidget {
  private:
    uchar m_screen;

    DSWidget * m_p_first_widget;
    DSListenerWidget * m_p_first_lwidget;

    // Focus Object Pointers
    DSListenerWidget * m_p_first_focusable;
    DSListenerWidget * m_p_last_focusable;
    DSListenerWidget * m_p_current_focusable;

    uint m_key_focus_right;
    uint m_key_focus_left;

  public:
    DSContainer( uchar screen );
    DSContainer( DSContainer * p_parent, PPOSITION p_pos, PDIMENSIONS p_dim );
    DSContainer( DSContainer * p_parent, PPOSITION p_pos, PDIMENSIONS p_dim, uint key_focus_left, uint key_focus_right );
    
    ~DSContainer(){};

    RESULT AddDSWidget( DSWidget * p_widget, char widget_type); 
    RESULT ClickEvent( PPOSITION p_pos );
    RESULT Draw(  );
    
    // Focusable Cycling
    RESULT FocusNext(); 
    RESULT FocusPrev();

    RESULT KeyPressEvent( uint key_pressed ); // Pending...
};

#endif

