#include "dslistenerwidget.h"

RESULT DSListenerWidget::AddKeyPressEvent( DSKeyPress * p_dskp_event ) {
  if (p_dskp_event == NULL)
    return INVALID_EVENT;

  // If list is empty, simply start it - END HERE
  if (m_p_first_dskp == NULL) {
    m_p_first_dskp = p_dskp_event;  return SUCCESS; }

  // This will add event at beginning of list
  p_dskp_event->SetNext(m_p_first_dskp); 
  m_p_first_dskp = p_dskp_event;
  return SUCCESS;
}

// Protected - Check if we were clicked. 
bool DSListenerWidget::CheckClickEvent( PPOSITION p_pos ) {
  return ((m_pos.x <= p_pos->x && m_pos.x + m_dim.width >= p_pos->x) && (m_pos.y <= p_pos->y && m_pos.y + m_dim.height >= p_pos->y));
}

// Returns the current next in line DSListenerWidget. If none, returns END_OF_LIST
RESULT DSListenerWidget::GetNextLW( DSListenerWidget * p_lw ) {
  if (m_p_next_lw == NULL)
    return END_OF_LIST;

  p_lw = m_p_next_lw;
  return SUCCESS;
}

RESULT DSListenerWidget::GetNextFocusLW( DSListenerWidget * p_lw ) {
  if (m_p_next_focuslw == NULL)
    return END_OF_LIST;

  p_lw = m_p_next_focuslw;
  return SUCCESS;
}

RESULT DSListenerWidget::GetPrevFocusLW( DSListenerWidget * p_lw ) {
  if (m_p_prev_focuslw == NULL)
    return END_OF_LIST;

  p_lw = m_p_prev_focuslw;
  return SUCCESS;
}


RESULT DSListenerWidget::SetClickEventFn( void (*p_fn)() ) {
  // we should check the address here but i don't know what values would be valid yet
  if (p_fn == NULL)
    return INVALID_CLICK_EVENT;

  m_p_click_event_fn = p_fn;
  return SUCCESS;
}

RESULT DSListenerWidget::SetNextLW( DSListenerWidget * p_lw ) {
  m_p_next_lw = p_lw;
  return SUCCESS;
}

RESULT DSListenerWidget::SetPreAndNextFLW( DSListenerWidget * p_prelw, DSListenerWidget * p_nextlw) {
  // No real checks, should be used by dsgui only to keep track of list
  m_p_next_focuslw = p_nextlw;
  m_p_prev_focuslw = p_prelw;
  return SUCCESS;
}

