#ifndef __DSLISTENERWIDGET_H__
#define __DSLISTENERWIDGET_H__


#include "dswidget.h"
#include "dskeypress.h"

/* ABSTRACT */
class DSListenerWidget: public DSWidget {
  protected:
    void (*m_p_click_event_fn)(); // fn ptr


    // Self Linked-List Parameters
    DSListenerWidget * m_p_next_lw; 
    DSListenerWidget * m_p_next_focuslw;
    DSListenerWidget * m_p_prev_focuslw;

    // Held Sub_Objects
    DSKeyPress * m_p_first_dskp;

    bool CheckClickEvent( PPOSITION p_pos );

  public:
    virtual RESULT AddKeyPressEvent( DSKeyPress * dskp_event ); // Partially Done, Might need to think of ordering ?
    virtual RESULT SetClickEventFn( void (*p_fn)() ); // Done

    virtual RESULT ClickEvent( PPOSITION p_pos ) = 0;
    virtual RESULT KeyPressEvent( unsigned int keyPress ) = 0;

    // List getters and Adders
    virtual RESULT GetNextLW( DSListenerWidget * p_lw ); // Done
    virtual RESULT GetNextFocusLW( DSListenerWidget * p_flw ); // Done
    virtual RESULT GetPrevFocusLW( DSListenerWidget * p_flw ); // Done
    virtual RESULT SetNextLW( DSListenerWidget * p_lw ); // Done
    virtual RESULT SetPreAndNextFLW( DSListenerWidget * p_prevlw, DSListenerWidget * p_nextlw ); // Done

};

#endif

