#ifndef __DSWIDGET_H__
#define __DSWIDGET_H__

#include "dsobject.h"

/* ABSTRACT */
class DSWidget: public DSObject {
  protected:
    POSITION m_pos;
    DIMENSIONS m_dim;

    char m_state;

    DSWidget * m_p_parent;
    DSWidget * m_p_next_widget; 

  public:
    virtual RESULT Draw( ) = 0; 

    // Setters and Getters
    virtual RESULT GetDimensions( PDIMENSIONS p_dim );
    virtual RESULT GetNext( DSWidget * p_dswidget ); 
    virtual RESULT GetParent( DSWidget * p_dswidget );
    virtual RESULT GetPosition( PPOSITION p_pos );
    virtual char   GetState(); 

    virtual RESULT SetDimensions( PDIMENSIONS p_dim ); //Check is relative to Parents
    virtual RESULT SetNext( DSWidget * p_dswidget ); // Done
    virtual RESULT SetParent( DSWidget * p_dswidget ); // Done, Resets m_pos, m_dims to 0,0 corner upon parent change if doesnt fit new 
    virtual RESULT SetPosition( PPOSITION p_pos ); // Done, Set is relative to Parents
    virtual RESULT SetState( char state ); // Done
};

#endif

