#ifndef __TYPES_H__
#define __TYPES_H__

// short form types
typedef unsigned char      uchar;
typedef unsigned short     ushort;
typedef unsigned int       uint;
typedef unsigned short int uint16;

// Almost every function should return this
typedef int RESULT;

//Setting to non-zero will break things!
#define SUCCESS                     0

// error codes
#define INVALID_SCREEN           -100
#define POSITION_OUT_OF_BOUNDS   -101
#define NO_CLICK                 -103
#define INVALID_WIDGET           -104
#define INVALID_STATE            -105
#define INVALID_CLICK_EVENT      -106
#define INVALID_EVENT            -107
#define INVALID_THEME_FONT_SMALL -108

// warning codes
#define STUB_FUNCTION             100
#define END_OF_LIST               101
#define DIMENSIONS_OUT_OF_BOUNDS  102

// screens
#define SCREEN_MAIN                  0
#define SCREEN_SUB                   1

// screen resolution
#define MAX_X                    0xFF
#define MAX_Y                     191

// states
#define STATE_ACTIVE                0
#define STATE_INACTIVE              1
#define STATE_OFF                   2 

// key events
#define KEY_NOT_FOUND               0
#define KEY_CALLED                  1
#define KEY_DEFAULT_FOCUS_RIGHT 1 << 4
#define KEY_DEFAULT_FOCUS_LEFT  1 << 5 

// Click events
#define MOUSE_EVENT_NOT_CLICKED     1
#define MOUSE_EVENT_CLICKED         0


//Object Types
#define TYPE_WIDGET                 0
#define TYPE_LISTENER               1
#define TYPE_FOCUSABLE              2

// Char Array Sizes
#define SIZE_LABEL      16

// structs
typedef struct _POSITION {
  uchar x, y;
} POSITION, *PPOSITION;

typedef struct _DIMENSIONS {
  uchar width, height;
} DIMENSIONS, *PDIMENSIONS;



#endif

